/*	$Id: dllist.c,v 1.5 2005/08/26 00:48:14 phil Exp $ */

/* BLURB gpl

                           Coda File System
                              Release 6

          Copyright (c) 1987-2005 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the terms of the GNU General Public Licence Version 2, as shown in the
file  LICENSE.  The  technical and financial  contributors to Coda are
listed in the file CREDITS.

*/

#include <dllist.h>

/*
 * Insert a new entry after the specified head..
 */
void list_add(struct dllist_head *entry, struct dllist_head *head)
{
    head->next->prev = entry;
    entry->next = head->next;
    entry->prev = head;
    head->next = entry;
}

/*
 * Delete a list entry by making the prev/next entries
 * point to each other.
 */


void list_del (struct dllist_head *le)
{
    le->prev->next = le->next;
    le->next->prev = le->prev;
    le->prev = le;
    le->next = le;
}

void list_init(struct dllist_head *lh)
{
    lh->prev = lh;
    lh->next = lh;
}

int list_empty(struct dllist_head *lh)
{
    return (lh->next == lh);
}
